﻿using Infragistics.Controls.Editors.Primitives;
using Infragistics.Windows;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace XCEDataView
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public DataView dataView { get; set; }
        public DataTable table { get; set; }
        public MainWindow()
        {
            InitializeComponent();
            this.table = new DataTable("table");
            DataColumn colItem1 = new DataColumn("Item1",
                Type.GetType("System.String"));
            DataColumn colItem2 = new DataColumn("Item2",
                Type.GetType("System.String"));
            colItem2.AllowDBNull = false;
            table.Columns.Add(colItem1);
            table.Columns.Add(colItem2);

            // Add five items.
            DataRow NewRow;
            for (int i = 0; i < 5; i++)
            {
                NewRow = table.NewRow();
                NewRow["Item1"] = "Item1 " + i;
                NewRow["Item2"] = "Item2 " + i;
                table.Rows.Add(NewRow);
            }
            table.AcceptChanges();

            // Create  DataView object
            this.dataView = new DataView(table);
            this.DataContext = this.dataView;
        }

        private void XamComboEditor_DataObjectRequested(object sender, Infragistics.HandleableObjectGenerationEventArgs e)
        {
            if (this.table != null && e.ObjectType.Equals(typeof(DataRowView)))
            {
                DataRowView drv = new DataView(this.table).AddNew();
                e.NewObject = drv;
                e.Handled = true;
            }
        }

        private void XamComboEditor_ItemAdding(object sender, Infragistics.Controls.Editors.ComboItemAddingEventArgs<Infragistics.Controls.Editors.ComboEditorItem> e)
        {
            DialogWindow1 win1 = new DialogWindow1();
            win1.DataContext = e.Item;
            win1.ShowDialog();
        }

        private void xce_ItemAdded(object sender, Infragistics.Controls.Editors.ComboItemAddedEventArgs<Infragistics.Controls.Editors.ComboEditorItem> e)
        {
            SpecializedTextBox sptxt = Utilities.GetDescendantFromType(this.xce, typeof(SpecializedTextBox), false) as SpecializedTextBox;
            if (sptxt != null)
            {
                Dispatcher.BeginInvoke(new Action(() =>
                {
                    sptxt.Text = "";

                }), DispatcherPriority.Loaded);
            }

            this.xce.SelectedIndex = -1;
        }
    }
}
